#include <stdlib.h>
#include "anamod.h"
#include "anamodsalsamodules.h"
#include "petsc.h"

int main(int argc,char **argv)
{
  PetscErrorCode ierr;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);
  
#define OUTPUT(a,b,c) printf("Category <%s> Component <%s> Type <%d>\n",a,b,c)
  ierr = AnaModRegisterSalsaModules(); CHKERRQ(ierr);
  {
    int ncat,icat; char **cats;
    ierr = GetCategories(&cats,&ncat); CHKERRQ(ierr);
    for (icat=0; icat<ncat; icat++) {
      int ncmp,icmp; char **cmps; AnalysisDataType *types;
      ierr = CategoryGetModules
	(cats[icat],&cmps,&types,NULL,&ncmp); CHKERRQ(ierr);
      for (icmp=0; icmp<ncmp; icmp++) {
	       OUTPUT(cats[icat],cmps[icmp],types[icmp]);

      }
    }
  }
  ierr = DeregisterModules(); CHKERRQ(ierr);

  PetscFinalize();
  PetscFunctionReturn(0);
}
